=== debian/changelog ===
cloudcompare (2.13.2+git20240821+ds-4) unstable; urgency=medium

  * d/rules: define laszip include dir. (Closes: #1122375)
  * d/watch: update to version 5.
  * d/control: add libcgal-dev to build-depends.

 -- Alex Myczko <tar@debian.org>  Thu, 11 Dec 2025 09:49:37 +0000

cloudcompare (2.13.2+git20240821+ds-3) unstable; urgency=medium

  * d/control: add liblaszip-dev to build-depends.
  * d/copyright: bump year.
  * d/README.Debian: added.

 -- Alex Myczko <tar@debian.org>  Mon, 08 Dec 2025 12:03:53 +0000

cloudcompare (2.13.2+git20240821+ds-2) unstable; urgency=medium

  * Bump standards version to 4.7.2.
  * d/control: Add Vcs fields.

 -- Alex Myczko <tar@debian.org>  Fri, 07 Nov 2025 09:59:06 +0100

cloudcompare (2.13.2+git20240821+ds-1) unstable; urgency=medium

  * New upstream version.
  * d/copyright: list Files-Excluded.
  * d/install: updated.
  * d/patches: lost.

 -- Alex Myczko <tar@debian.org>  Wed, 21 Aug 2024 13:40:18 +0000

cloudcompare (2.11.3-8) unstable; urgency=medium

  * Ack NMUs.
  * d/control: drop build-depends libcgal-dev and libcgal-qt5-dev.
    (Closes: #1075971)
  * Bump standards version to 4.7.0.

 -- Alex Myczko <tar@debian.org>  Fri, 26 Jul 2024 11:27:08 +0000
