=== debian/watch ===
Version: 5

# GitHub hosted projects
Template: Github
Owner: CloudCompare
Project: CloudCompare
Update-Script: uupdate
